ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/AnyEvent/lib/AnyEvent.pm
(Generate patch)

Comparing AnyEvent/lib/AnyEvent.pm (file contents):
Revision 1.202 by root, Wed Apr 1 15:29:00 2009 UTC vs.
Revision 1.214 by root, Mon Jun 22 11:57:05 2009 UTC

1=head1 NAME 1=head1 NAME
2 2
3AnyEvent - provide framework for multiple event loops 3AnyEvent - provide framework for multiple event loops
4 4
5EV, Event, Glib, Tk, Perl, Event::Lib, Qt, POE - various supported event loops 5EV, Event, Glib, Tk, Perl, Event::Lib, Qt and POE are various supported
6event loops.
6 7
7=head1 SYNOPSIS 8=head1 SYNOPSIS
8 9
9 use AnyEvent; 10 use AnyEvent;
10 11
12 # file descriptor readable
11 my $w = AnyEvent->io (fh => $fh, poll => "r|w", cb => sub { ... }); 13 my $w = AnyEvent->io (fh => $fh, poll => "r", cb => sub { ... });
12 14
15 # one-shot or repeating timers
13 my $w = AnyEvent->timer (after => $seconds, cb => sub { ... }); 16 my $w = AnyEvent->timer (after => $seconds, cb => sub { ... });
14 my $w = AnyEvent->timer (after => $seconds, interval => $seconds, cb => ... 17 my $w = AnyEvent->timer (after => $seconds, interval => $seconds, cb => ...
15 18
16 print AnyEvent->now; # prints current event loop time 19 print AnyEvent->now; # prints current event loop time
17 print AnyEvent->time; # think Time::HiRes::time or simply CORE::time. 20 print AnyEvent->time; # think Time::HiRes::time or simply CORE::time.
18 21
22 # POSIX signal
19 my $w = AnyEvent->signal (signal => "TERM", cb => sub { ... }); 23 my $w = AnyEvent->signal (signal => "TERM", cb => sub { ... });
20 24
25 # child process exit
21 my $w = AnyEvent->child (pid => $pid, cb => sub { 26 my $w = AnyEvent->child (pid => $pid, cb => sub {
22 my ($pid, $status) = @_; 27 my ($pid, $status) = @_;
23 ... 28 ...
24 }); 29 });
30
31 # called when event loop idle (if applicable)
32 my $w = AnyEvent->idle (cb => sub { ... });
25 33
26 my $w = AnyEvent->condvar; # stores whether a condition was flagged 34 my $w = AnyEvent->condvar; # stores whether a condition was flagged
27 $w->send; # wake up current and all future recv's 35 $w->send; # wake up current and all future recv's
28 $w->recv; # enters "main loop" till $condvar gets ->send 36 $w->recv; # enters "main loop" till $condvar gets ->send
29 # use a condvar in callback mode: 37 # use a condvar in callback mode:
319 327
320In either case, if you care (and in most cases, you don't), then you 328In either case, if you care (and in most cases, you don't), then you
321can get whatever behaviour you want with any event loop, by taking the 329can get whatever behaviour you want with any event loop, by taking the
322difference between C<< AnyEvent->time >> and C<< AnyEvent->now >> into 330difference between C<< AnyEvent->time >> and C<< AnyEvent->now >> into
323account. 331account.
332
333=item AnyEvent->now_update
334
335Some event loops (such as L<EV> or L<AnyEvent::Impl::Perl>) cache
336the current time for each loop iteration (see the discussion of L<<
337AnyEvent->now >>, above).
338
339When a callback runs for a long time (or when the process sleeps), then
340this "current" time will differ substantially from the real time, which
341might affect timers and time-outs.
342
343When this is the case, you can call this method, which will update the
344event loop's idea of "current time".
345
346Note that updating the time I<might> cause some events to be handled.
324 347
325=back 348=back
326 349
327=head2 SIGNAL WATCHERS 350=head2 SIGNAL WATCHERS
328 351
395 ); 418 );
396 419
397 # do something else, then wait for process exit 420 # do something else, then wait for process exit
398 $done->recv; 421 $done->recv;
399 422
423=head2 IDLE WATCHERS
424
425Sometimes there is a need to do something, but it is not so important
426to do it instantly, but only when there is nothing better to do. This
427"nothing better to do" is usually defined to be "no other events need
428attention by the event loop".
429
430Idle watchers ideally get invoked when the event loop has nothing
431better to do, just before it would block the process to wait for new
432events. Instead of blocking, the idle watcher is invoked.
433
434Most event loops unfortunately do not really support idle watchers (only
435EV, Event and Glib do it in a usable fashion) - for the rest, AnyEvent
436will simply call the callback "from time to time".
437
438Example: read lines from STDIN, but only process them when the
439program is otherwise idle:
440
441 my @lines; # read data
442 my $idle_w;
443 my $io_w = AnyEvent->io (fh => \*STDIN, poll => 'r', cb => sub {
444 push @lines, scalar <STDIN>;
445
446 # start an idle watcher, if not already done
447 $idle_w ||= AnyEvent->idle (cb => sub {
448 # handle only one line, when there are lines left
449 if (my $line = shift @lines) {
450 print "handled when idle: $line";
451 } else {
452 # otherwise disable the idle watcher again
453 undef $idle_w;
454 }
455 });
456 });
457
400=head2 CONDITION VARIABLES 458=head2 CONDITION VARIABLES
401 459
402If you are familiar with some event loops you will know that all of them 460If you are familiar with some event loops you will know that all of them
403require you to run some blocking "loop", "run" or similar function that 461require you to run some blocking "loop", "run" or similar function that
404will actively watch for new events and call your callbacks. 462will actively watch for new events and call your callbacks.
873no warnings; 931no warnings;
874use strict qw(vars subs); 932use strict qw(vars subs);
875 933
876use Carp; 934use Carp;
877 935
878our $VERSION = 4.35; 936our $VERSION = 4.411;
879our $MODEL; 937our $MODEL;
880 938
881our $AUTOLOAD; 939our $AUTOLOAD;
882our @ISA; 940our @ISA;
883 941
884our @REGISTRY; 942our @REGISTRY;
885 943
886our $WIN32; 944our $WIN32;
887 945
888BEGIN { 946BEGIN {
889 my $win32 = ! ! ($^O =~ /mswin32/i); 947 eval "sub WIN32(){ " . (($^O =~ /mswin32/i)*1) ." }";
890 eval "sub WIN32(){ $win32 }"; 948 eval "sub TAINT(){ " . (${^TAINT}*1) . " }";
949
950 delete @ENV{grep /^PERL_ANYEVENT_/, keys %ENV}
951 if ${^TAINT};
891} 952}
892 953
893our $verbose = $ENV{PERL_ANYEVENT_VERBOSE}*1; 954our $verbose = $ENV{PERL_ANYEVENT_VERBOSE}*1;
894 955
895our %PROTOCOL; # (ipv4|ipv6) => (1|2), higher numbers are preferred 956our %PROTOCOL; # (ipv4|ipv6) => (1|2), higher numbers are preferred
915 [POE::Kernel:: => AnyEvent::Impl::POE::], # lasciate ogni speranza 976 [POE::Kernel:: => AnyEvent::Impl::POE::], # lasciate ogni speranza
916 [Wx:: => AnyEvent::Impl::POE::], 977 [Wx:: => AnyEvent::Impl::POE::],
917 [Prima:: => AnyEvent::Impl::POE::], 978 [Prima:: => AnyEvent::Impl::POE::],
918); 979);
919 980
920our %method = map +($_ => 1), qw(io timer time now signal child condvar one_event DESTROY); 981our %method = map +($_ => 1),
982 qw(io timer time now now_update signal child idle condvar one_event DESTROY);
921 983
922our @post_detect; 984our @post_detect;
923 985
924sub post_detect(&) { 986sub post_detect(&) {
925 my ($cb) = @_; 987 my ($cb) = @_;
930 1 992 1
931 } else { 993 } else {
932 push @post_detect, $cb; 994 push @post_detect, $cb;
933 995
934 defined wantarray 996 defined wantarray
935 ? bless \$cb, "AnyEvent::Util::PostDetect" 997 ? bless \$cb, "AnyEvent::Util::postdetect"
936 : () 998 : ()
937 } 999 }
938} 1000}
939 1001
940sub AnyEvent::Util::PostDetect::DESTROY { 1002sub AnyEvent::Util::postdetect::DESTROY {
941 @post_detect = grep $_ != ${$_[0]}, @post_detect; 1003 @post_detect = grep $_ != ${$_[0]}, @post_detect;
942} 1004}
943 1005
944sub detect() { 1006sub detect() {
945 unless ($MODEL) { 1007 unless ($MODEL) {
982 last; 1044 last;
983 } 1045 }
984 } 1046 }
985 1047
986 $MODEL 1048 $MODEL
987 or die "No event module selected for AnyEvent and autodetect failed. Install any one of these modules: EV, Event or Glib."; 1049 or die "No event module selected for AnyEvent and autodetect failed. Install any one of these modules: EV, Event or Glib.\n";
988 } 1050 }
989 } 1051 }
990 1052
991 push @{"$MODEL\::ISA"}, "AnyEvent::Base"; 1053 push @{"$MODEL\::ISA"}, "AnyEvent::Base";
992 1054
1022 my ($rw, $mode) = $poll eq "r" ? ($r, "<") 1084 my ($rw, $mode) = $poll eq "r" ? ($r, "<")
1023 : $poll eq "w" ? ($w, ">") 1085 : $poll eq "w" ? ($w, ">")
1024 : Carp::croak "AnyEvent->io requires poll set to either 'r' or 'w'"; 1086 : Carp::croak "AnyEvent->io requires poll set to either 'r' or 'w'";
1025 1087
1026 open my $fh2, "$mode&" . fileno $fh 1088 open my $fh2, "$mode&" . fileno $fh
1027 or die "cannot dup() filehandle: $!"; 1089 or die "cannot dup() filehandle: $!,";
1028 1090
1029 # we assume CLOEXEC is already set by perl in all important cases 1091 # we assume CLOEXEC is already set by perl in all important cases
1030 1092
1031 ($fh2, $rw) 1093 ($fh2, $rw)
1032} 1094}
1033 1095
1034package AnyEvent::Base; 1096package AnyEvent::Base;
1035 1097
1036# default implementation for now and time 1098# default implementations for many methods
1037 1099
1038BEGIN { 1100BEGIN {
1039 if (eval "use Time::HiRes (); time (); 1") { 1101 if (eval "use Time::HiRes (); Time::HiRes::time (); 1") {
1040 *_time = \&Time::HiRes::time; 1102 *_time = \&Time::HiRes::time;
1041 # if (eval "use POSIX (); (POSIX::times())... 1103 # if (eval "use POSIX (); (POSIX::times())...
1042 } else { 1104 } else {
1043 *_time = sub { time }; # epic fail 1105 *_time = sub { time }; # epic fail
1044 } 1106 }
1045} 1107}
1046 1108
1047sub time { _time } 1109sub time { _time }
1048sub now { _time } 1110sub now { _time }
1111sub now_update { }
1049 1112
1050# default implementation for ->condvar 1113# default implementation for ->condvar
1051 1114
1052sub condvar { 1115sub condvar {
1053 bless { @_ == 3 ? (_ae_cb => $_[2]) : () }, AnyEvent::CondVar:: 1116 bless { @_ == 3 ? (_ae_cb => $_[2]) : () }, "AnyEvent::CondVar"
1054} 1117}
1055 1118
1056# default implementation for ->signal 1119# default implementation for ->signal
1057 1120
1058our ($SIGPIPE_R, $SIGPIPE_W, %SIG_CB, %SIG_EV, $SIG_IO); 1121our ($SIGPIPE_R, $SIGPIPE_W, %SIG_CB, %SIG_EV, $SIG_IO);
1082 AnyEvent::Util::fh_nonblocking ($SIGPIPE_W) if $SIGPIPE_W; # just in case 1145 AnyEvent::Util::fh_nonblocking ($SIGPIPE_W) if $SIGPIPE_W; # just in case
1083 } else { 1146 } else {
1084 pipe $SIGPIPE_R, $SIGPIPE_W; 1147 pipe $SIGPIPE_R, $SIGPIPE_W;
1085 fcntl $SIGPIPE_R, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_R; 1148 fcntl $SIGPIPE_R, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_R;
1086 fcntl $SIGPIPE_W, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_W; # just in case 1149 fcntl $SIGPIPE_W, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_W; # just in case
1150
1151 # not strictly required, as $^F is normally 2, but let's make sure...
1152 fcntl $SIGPIPE_R, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1153 fcntl $SIGPIPE_W, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1087 } 1154 }
1088 1155
1089 $SIGPIPE_R 1156 $SIGPIPE_R
1090 or Carp::croak "AnyEvent: unable to create a signal reporting pipe: $!\n"; 1157 or Carp::croak "AnyEvent: unable to create a signal reporting pipe: $!\n";
1091
1092 # not strictly required, as $^F is normally 2, but let's make sure...
1093 fcntl $SIGPIPE_R, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1094 fcntl $SIGPIPE_W, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1095 1158
1096 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R, poll => "r", cb => \&_signal_exec); 1159 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R, poll => "r", cb => \&_signal_exec);
1097 } 1160 }
1098 1161
1099 my $signal = uc $arg{signal} 1162 my $signal = uc $arg{signal}
1104 local $!; 1167 local $!;
1105 syswrite $SIGPIPE_W, "\x00", 1 unless %SIG_EV; 1168 syswrite $SIGPIPE_W, "\x00", 1 unless %SIG_EV;
1106 undef $SIG_EV{$signal}; 1169 undef $SIG_EV{$signal};
1107 }; 1170 };
1108 1171
1109 bless [$signal, $arg{cb}], "AnyEvent::Base::Signal" 1172 bless [$signal, $arg{cb}], "AnyEvent::Base::signal"
1110} 1173}
1111 1174
1112sub AnyEvent::Base::Signal::DESTROY { 1175sub AnyEvent::Base::signal::DESTROY {
1113 my ($signal, $cb) = @{$_[0]}; 1176 my ($signal, $cb) = @{$_[0]};
1114 1177
1115 delete $SIG_CB{$signal}{$cb}; 1178 delete $SIG_CB{$signal}{$cb};
1116 1179
1180 # delete doesn't work with older perls - they then
1181 # print weird messages, or just unconditionally exit
1182 # instead of getting the default action.
1117 delete $SIG{$signal} unless keys %{ $SIG_CB{$signal} }; 1183 undef $SIG{$signal} unless keys %{ $SIG_CB{$signal} };
1118} 1184}
1119 1185
1120# default implementation for ->child 1186# default implementation for ->child
1121 1187
1122our %PID_CB; 1188our %PID_CB;
1123our $CHLD_W; 1189our $CHLD_W;
1124our $CHLD_DELAY_W; 1190our $CHLD_DELAY_W;
1125our $PID_IDLE;
1126our $WNOHANG; 1191our $WNOHANG;
1127 1192
1128sub _child_wait { 1193sub _sigchld {
1129 while (0 < (my $pid = waitpid -1, $WNOHANG)) { 1194 while (0 < (my $pid = waitpid -1, $WNOHANG)) {
1130 $_->($pid, $?) for (values %{ $PID_CB{$pid} || {} }), 1195 $_->($pid, $?) for (values %{ $PID_CB{$pid} || {} }),
1131 (values %{ $PID_CB{0} || {} }); 1196 (values %{ $PID_CB{0} || {} });
1132 } 1197 }
1133
1134 undef $PID_IDLE;
1135}
1136
1137sub _sigchld {
1138 # make sure we deliver these changes "synchronous" with the event loop.
1139 $CHLD_DELAY_W ||= AnyEvent->timer (after => 0, cb => sub {
1140 undef $CHLD_DELAY_W;
1141 &_child_wait;
1142 });
1143} 1198}
1144 1199
1145sub child { 1200sub child {
1146 my (undef, %arg) = @_; 1201 my (undef, %arg) = @_;
1147 1202
1148 defined (my $pid = $arg{pid} + 0) 1203 defined (my $pid = $arg{pid} + 0)
1149 or Carp::croak "required option 'pid' is missing"; 1204 or Carp::croak "required option 'pid' is missing";
1150 1205
1151 $PID_CB{$pid}{$arg{cb}} = $arg{cb}; 1206 $PID_CB{$pid}{$arg{cb}} = $arg{cb};
1152 1207
1153 unless ($WNOHANG) {
1154 $WNOHANG = eval { local $SIG{__DIE__}; require POSIX; &POSIX::WNOHANG } || 1; 1208 $WNOHANG ||= eval { local $SIG{__DIE__}; require POSIX; &POSIX::WNOHANG } || 1;
1155 }
1156 1209
1157 unless ($CHLD_W) { 1210 unless ($CHLD_W) {
1158 $CHLD_W = AnyEvent->signal (signal => 'CHLD', cb => \&_sigchld); 1211 $CHLD_W = AnyEvent->signal (signal => 'CHLD', cb => \&_sigchld);
1159 # child could be a zombie already, so make at least one round 1212 # child could be a zombie already, so make at least one round
1160 &_sigchld; 1213 &_sigchld;
1161 } 1214 }
1162 1215
1163 bless [$pid, $arg{cb}], "AnyEvent::Base::Child" 1216 bless [$pid, $arg{cb}], "AnyEvent::Base::child"
1164} 1217}
1165 1218
1166sub AnyEvent::Base::Child::DESTROY { 1219sub AnyEvent::Base::child::DESTROY {
1167 my ($pid, $cb) = @{$_[0]}; 1220 my ($pid, $cb) = @{$_[0]};
1168 1221
1169 delete $PID_CB{$pid}{$cb}; 1222 delete $PID_CB{$pid}{$cb};
1170 delete $PID_CB{$pid} unless keys %{ $PID_CB{$pid} }; 1223 delete $PID_CB{$pid} unless keys %{ $PID_CB{$pid} };
1171 1224
1172 undef $CHLD_W unless keys %PID_CB; 1225 undef $CHLD_W unless keys %PID_CB;
1226}
1227
1228# idle emulation is done by simply using a timer, regardless
1229# of whether the process is idle or not, and not letting
1230# the callback use more than 50% of the time.
1231sub idle {
1232 my (undef, %arg) = @_;
1233
1234 my ($cb, $w, $rcb) = $arg{cb};
1235
1236 $rcb = sub {
1237 if ($cb) {
1238 $w = _time;
1239 &$cb;
1240 $w = _time - $w;
1241
1242 # never use more then 50% of the time for the idle watcher,
1243 # within some limits
1244 $w = 0.0001 if $w < 0.0001;
1245 $w = 5 if $w > 5;
1246
1247 $w = AnyEvent->timer (after => $w, cb => $rcb);
1248 } else {
1249 # clean up...
1250 undef $w;
1251 undef $rcb;
1252 }
1253 };
1254
1255 $w = AnyEvent->timer (after => 0.05, cb => $rcb);
1256
1257 bless \\$cb, "AnyEvent::Base::idle"
1258}
1259
1260sub AnyEvent::Base::idle::DESTROY {
1261 undef $${$_[0]};
1173} 1262}
1174 1263
1175package AnyEvent::CondVar; 1264package AnyEvent::CondVar;
1176 1265
1177our @ISA = AnyEvent::CondVar::Base::; 1266our @ISA = AnyEvent::CondVar::Base::;
1251so on. 1340so on.
1252 1341
1253=head1 ENVIRONMENT VARIABLES 1342=head1 ENVIRONMENT VARIABLES
1254 1343
1255The following environment variables are used by this module or its 1344The following environment variables are used by this module or its
1256submodules: 1345submodules.
1346
1347Note that AnyEvent will remove I<all> environment variables starting with
1348C<PERL_ANYEVENT_> from C<%ENV> when it is loaded while taint mode is
1349enabled.
1257 1350
1258=over 4 1351=over 4
1259 1352
1260=item C<PERL_ANYEVENT_VERBOSE> 1353=item C<PERL_ANYEVENT_VERBOSE>
1261 1354
1867 use AnyEvent; 1960 use AnyEvent;
1868 1961
1869Similar considerations apply to $ENV{PERL_ANYEVENT_VERBOSE}, as that can 1962Similar considerations apply to $ENV{PERL_ANYEVENT_VERBOSE}, as that can
1870be used to probe what backend is used and gain other information (which is 1963be used to probe what backend is used and gain other information (which is
1871probably even less useful to an attacker than PERL_ANYEVENT_MODEL), and 1964probably even less useful to an attacker than PERL_ANYEVENT_MODEL), and
1872$ENV{PERL_ANYEGENT_STRICT}. 1965$ENV{PERL_ANYEVENT_STRICT}.
1873 1966
1874 1967
1875=head1 BUGS 1968=head1 BUGS
1876 1969
1877Perl 5.8 has numerous memleaks that sometimes hit this module and are hard 1970Perl 5.8 has numerous memleaks that sometimes hit this module and are hard

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines